package univlyon1.recettes;

import univlyon1.recettes.actions.*;
import univlyon1.recettes.dao.RecetteORMDAO;

import javax.persistence.EntityManager;
import javax.persistence.Persistence;
import java.io.*;

/**
 * Created by Emmanuel Coquery on 12/09/2015.
 */
public class RecettesApp {

    private RecetteORMDAO dao;
    private PrintStream out;
    private BufferedReader in;
    private MenuAction menu;

    public RecettesApp() {
        EntityManager em = Persistence.createEntityManagerFactory("pu-mif18").createEntityManager();
        dao = new RecetteORMDAO();
        dao.setEntityManager(em);
        out = System.out;
        in = new BufferedReader(new InputStreamReader(System.in));
        menu = new MenuAction(in, out, dao, "menu principal", "fin",
                new ListIngredientsAction(dao),
                new AfficheIngredientAction(in, out, dao),
                new CreerIngredientAction(in, out, dao),
                new ListRecettesAction(dao),
                new AfficheRecetteAction(in, out, dao),
                new AfficheRecettesIngredientsAction(in, out, dao),
                new CreateEditRecetteAction(in,out,dao),
                new QuitAction()
        );
    }

    public void menu() throws IOException {
        menu.run();
    }

    public static void main(String[] args) throws IOException {
        RecettesApp app = new RecettesApp();
        app.menu();
        System.out.println("Quit");
        System.exit(0);
    }
}
