package univlyon1.recettes.actions;

import univlyon1.recettes.dao.RecetteORMDAO;
import univlyon1.recettes.modele.Instruction;
import univlyon1.recettes.modele.Quantite;
import univlyon1.recettes.modele.Recette;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.PrintStream;

/**
 * Created by Emmanuel Coquery on 12/09/2015.
 */
public class AfficheRecetteAction extends SimpleQuestionAction {

    public AfficheRecetteAction(BufferedReader in, PrintStream out, RecetteORMDAO dao) {
        super(in, out, dao);
    }

    @Override
    public String getDescription() {
        return "Afficher une recette";
    }

    @Override
    protected String getQuestion() {
        return "Entrer le nom de la recette";
    }

    @Override
    public String runWithAnswer(String answer) throws IOException {
        Recette recette = dao.getRecetteByNom(answer);
        if (recette != null) {
            StringBuilder sb = new StringBuilder();
            sb.append(recette.getNom());
            sb.append("\n\n");
            sb.append(recette.getDescription());
            sb.append("\n\n");
            for(Quantite q : recette.getIngredients()) {
                sb.append(q);
                sb.append("\n");
            }
            int numEtape = 1;
            for(Instruction ins : recette.getInstructions()) {
                sb.append(numEtape);
                sb.append(": ");
                sb.append(ins.getDescription());
                sb.append("\n");
                ++numEtape;
            }
            return sb.toString();
        } else {
            return "Cette recette nous est inconnue";
        }
    }
}
