package univlyon1.recettes.actions;

import univlyon1.recettes.dao.RecetteORMDAO;
import univlyon1.recettes.modele.Recette;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.PrintStream;

/**
 * Created by Emmanuel Coquery on 16/09/2015.
 */
public class AfficheRecettesIngredientsAction extends SimpleQuestionAction {


    public AfficheRecettesIngredientsAction(BufferedReader in, PrintStream out, RecetteORMDAO dao) {
        super(in, out, dao);
    }

    @Override
    public String getDescription() {
        return "Afficher les recettes contenant un ingredient particulier";
    }

    @Override
    protected String getQuestion() {
        return "Entrer le nom de l'ingrdient";
    }

    @Override
    protected String runWithAnswer(String answer) throws IOException {
        StringBuilder sb = new StringBuilder("Recettes contenant "+answer+":\n");
        for(Recette r : dao.findRecetteByIngredientName(answer)) {
            sb.append(r.getNom());
            sb.append("\n");
        }
        return sb.toString();
    }


}
