package univlyon1.recettes.actions;

import univlyon1.recettes.dao.RecetteORMDAO;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.PrintStream;

/**
 * Created by Emmanuel Coquery on 16/09/2015.
 */
public abstract class IODAOAction implements Action {

    protected BufferedReader in;
    protected PrintStream out;
    protected RecetteORMDAO dao;

    public IODAOAction(BufferedReader in, PrintStream out, RecetteORMDAO dao) {
        this.dao = dao;
        this.out = out;
        this.in = in;
    }

    protected void print(Object o) {
        out.print(o);
    }

    protected void println(Object o) {
        out.println(o);
    }

    protected String read() throws IOException {
        return in.readLine();
    }

    protected String readMultiLines() throws IOException {
        out.println("(Terminer avec une ligne vide)");
        StringBuilder sb = new StringBuilder();
        String ligne;
        do {
            ligne = read();
            if (ligne != null && !"".equals(ligne)) {
                sb.append(ligne);
                sb.append("\n");
            }
        } while (ligne != null && !"".equals(ligne));
        return sb.toString();
    }

    protected int readInt() throws IOException {
        do {
            String ans = in.readLine();
            if (ans != null) {
                try {
                    return Integer.parseInt(ans);
                } catch (NumberFormatException e) {
                    out.println("Entrer un nombre");
                }
            } else {
                return -1;
            }
        } while (true);
    }

    protected double readDouble() throws IOException {
        do {
            String ans = in.readLine();
            if (ans != null) {
                try {
                    return Double.parseDouble(ans);
                } catch (NumberFormatException e) {
                    out.println("Entrer un nombre");
                }
            } else {
                return -1;
            }
        } while (true);
    }
}
