package univlyon1.recettes.actions;

import univlyon1.recettes.dao.RecetteORMDAO;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

/**
 * Created by Emmanuel Coquery on 16/09/2015.
 */
public class MenuAction extends IODAOAction {

    protected List<Action> actions;
    protected String endValue;
    protected String description;

    public MenuAction(BufferedReader in, PrintStream out, RecetteORMDAO dao,
                      String description, String endValue, Action... actions) {
        super(in, out, dao);
        this.description = description;
        this.endValue = endValue;
        this.actions = new ArrayList<>();
        this.actions.addAll(Arrays.asList(actions));
    }


    @Override
    public String getDescription() {
        return description;
    }

    @Override
    public String run() throws IOException {
        menu();
        return endValue;
    }

    protected void menu() throws IOException {
        int ans;
        do {
            printMenu();
            out.println();
            out.print("Entrez votre choix (1-" + (actions.size()) + "): ");
            ans = readInt() - 1;
            if (ans >= 0 && ans < actions.size()) {
                String actionResult = actions.get(ans).run();
                if (actionResult == null) {
                    return;
                } else {
                    out.println(actionResult);
                }
            }
            out.println("----------------------------");
        } while (ans >= 0 && ans < actions.size());
    }

    private void printMenu() {
        for (int i = 0; i < actions.size(); ++i) {
            out.print(i + 1);
            out.println(": " + actions.get(i).getDescription());
        }
    }

    public void addAction(Action action) {
        actions.add(action);
    }
}
